﻿Imports System.Drawing

Public Class ColorDialogEx
    Public SelColor As Color = Nothing
    Private bmp As Bitmap
    Private ManualChange As Boolean = False

    Private Sub tb_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbRed.ValueChanged, tbGreen.ValueChanged, tbBlue.ValueChanged
        If Not ManualChange Then
            ManualChange = True

            txtRed.Text = tbRed.Value
            txtGreen.Text = tbGreen.Value
            txtBlue.Text = tbBlue.Value

            txtColor.BackColor = Color.FromArgb(tbRed.Value, tbGreen.Value, tbBlue.Value)
            SelColor = txtColor.BackColor

            ManualChange = False
        End If
    End Sub

    Private Sub pbAllColors_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbAllColors.MouseMove
        If pbAllColors.ClientRectangle.Contains(e.X, e.Y) Then
            ManualChange = True

            Dim MousePos As New Point(e.X, e.Y)
            If e.X < 0 Then MousePos.X = 0
            If e.X > (bmp.Width - 1) Then MousePos.X = My.Resources.Colors.Width - 1
            If e.Y < 0 Then MousePos.Y = 0
            If e.Y > (bmp.Height - 1) Then MousePos.Y = My.Resources.Colors.Height - 1

            Dim NewCol As Color = bmp.GetPixel(MousePos.X, MousePos.Y)
            tbRed.Value = NewCol.R
            tbGreen.Value = NewCol.G
            tbBlue.Value = NewCol.B

            txtRed.Text = NewCol.R
            txtGreen.Text = NewCol.G
            txtBlue.Text = NewCol.B

            txtColor.BackColor = Color.FromArgb(NewCol.R, NewCol.G, NewCol.B)
            SelColor = txtColor.BackColor

            ManualChange = False
        End If
    End Sub

    Private Sub ColorDialogEx_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ManualChange = True

        pbAllColors.Image = My.Resources.Colors

        bmp = New Bitmap(pbAllColors.Width, pbAllColors.Height)
        Using g As Graphics = Graphics.FromImage(bmp)
            g.DrawImage(My.Resources.Colors, New Rectangle(0, 0, bmp.Width, bmp.Height), New Rectangle(0, 0, My.Resources.Colors.Width, My.Resources.Colors.Height), GraphicsUnit.Pixel)
        End Using

        tbRed.Value = SelColor.R
        tbGreen.Value = SelColor.G
        tbBlue.Value = SelColor.B

        txtRed.Text = SelColor.R
        txtGreen.Text = SelColor.G
        txtBlue.Text = SelColor.B

        txtColor.BackColor = Color.FromArgb(SelColor.R, SelColor.G, SelColor.B)

        ManualChange = False
    End Sub

    Private Sub mniCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniCancel.Click
        SelColor = Nothing
        Close()
    End Sub

    Private Sub mniOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniOk.Click
        Close()
    End Sub

    Private Sub txt_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtRed.TextChanged, txtGreen.TextChanged, txtBlue.TextChanged
        If Not ManualChange Then
            ManualChange = True

            If txtRed.Text = String.Empty Then txtRed.Text = 0
            If Not IsNumeric(txtRed.Text) Then txtRed.Text = 0
            If txtRed.Text > 255 Then txtRed.Text = 255

            If txtGreen.Text = String.Empty Then txtGreen.Text = 0
            If Not IsNumeric(txtGreen.Text) Then txtGreen.Text = 0
            If txtGreen.Text > 255 Then txtGreen.Text = 255

            If txtBlue.Text = String.Empty Then txtBlue.Text = 0
            If Not IsNumeric(txtBlue.Text) Then txtBlue.Text = 0
            If txtBlue.Text > 255 Then txtBlue.Text = 255

            tbRed.Value = txtRed.Text
            tbGreen.Value = txtGreen.Text
            tbBlue.Value = txtBlue.Text

            txtColor.BackColor = Color.FromArgb(tbRed.Value, tbGreen.Value, tbBlue.Value)
            SelColor = txtColor.BackColor

            ManualChange = False
        End If
    End Sub

End Class