﻿Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.IO
Imports System.Windows.Forms

Public Class Settings
    'Get the directory of this Widget
    Private DirWidget As String = Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase)

    'Variable to load data
    Public LoadData As Boolean = False

    'Variable to save data
    Public SaveData As Boolean = False

    'Bitmap of Clock to show
    Private ClockBmp As Bitmap

    'Timer to redraw clock
    Private WithEvents tmr As Timer

    Private Sub mniCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniCancel.Click
        'Close form
        Close()
    End Sub

    Private Sub mniOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniOk.Click
        'Save data
        SaveData = True
        'Close form
        Close()
    End Sub

    Private Sub Settings_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        'Dispose timer
        If tmr IsNot Nothing Then
            tmr.Dispose()
            tmr = Nothing
        End If

        'Dispose picturebox bitmap
        If pctClock.Image IsNot Nothing Then
            pctClock.Image.Dispose()
            pctClock.Image = Nothing
        End If

        'Dispose clockbmp
        If ClockBmp IsNot Nothing Then
            ClockBmp.Dispose()
            ClockBmp = Nothing
        End If
    End Sub

    Private Sub Settings_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Set timer to update Clock Bitmap
        tmr = New Timer
        tmr.Interval = 1000
        tmr.Enabled = True
    End Sub

    Private Sub tmr_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmr.Tick
        'Redraw clock every seconds
        SetClockBmp()
    End Sub

    Public Sub SetClockBmp()
        'If load data exit now
        If LoadData Then Exit Sub

        'If not exist clock image exit now
        If Not File.Exists(DirWidget & "\Clocks\" & ClockType.Text) Then Exit Sub

        ClockBmp = New Bitmap(pctClock.Width, pctClock.Height)
        Using g As Graphics = Graphics.FromImage(ClockBmp)
            g.Clear(BackColor)
            Using FileClock As New Bitmap(DirWidget & "\Clocks\" & ClockType.Text)
                Dim ia As New ImageAttributes
                ia.SetColorKey(FileClock.GetPixel(0, 0), FileClock.GetPixel(0, 0))

                'Draw clock in Bitmap
                DrawAnalogClock(g, FileClock, New Rectangle(0, 0, ClockBmp.Width, ClockBmp.Height), ia, ClockArrowType.Text, ClockBackArrow.Checked, ClockColorHour.BackColor, ClockDimHour.Value, ClockColorMin.BackColor, ClockDimMin.Value, ClockColorSec.BackColor, ClockDimSec.Value, DelayHour.Value)
            End Using
        End Using

        'Set picture box image
        If pctClock.Image IsNot Nothing Then
            pctClock.Image.Dispose()
            pctClock.Image = Nothing
        End If
        pctClock.Image = ClockBmp
    End Sub

    Private Sub ClockColorSec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClockColorSec.Click
        Using frm As New ColorDialogEx
            frm.SelColor = ClockColorSec.BackColor
            frm.ShowDialog()

            If frm.SelColor.IsEmpty = False Then ClockColorSec.BackColor = frm.SelColor
        End Using
    End Sub

    Private Sub ClockColorMin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClockColorMin.Click
        Using frm As New ColorDialogEx
            frm.SelColor = ClockColorMin.BackColor
            frm.ShowDialog()

            If frm.SelColor.IsEmpty = False Then ClockColorMin.BackColor = frm.SelColor
        End Using
    End Sub

    Private Sub ClockColorHour_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClockColorHour.Click
        Using frm As New ColorDialogEx
            frm.SelColor = ClockColorHour.BackColor
            frm.ShowDialog()

            If frm.SelColor.IsEmpty = False Then ClockColorHour.BackColor = frm.SelColor
        End Using
    End Sub
End Class