﻿Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.IO
Imports System.Windows.Forms

Public Class Settings
    'Get the directory of this Widget
    Private DirWidget As String = Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase)

    'Variable to save data
    Public SaveData As Boolean = False

    'Bitmap of Border to show
    Private BorderBmp As Bitmap

    Private Sub mniCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniCancel.Click
        'Close form
        Close()
    End Sub

    Private Sub mniOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniOk.Click
        'Save data
        SaveData = True
        'Close form
        Close()
    End Sub

    Private Sub Settings_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        'Dispose picturebox bitmap
        If pctBorder.Image IsNot Nothing Then
            pctBorder.Image.Dispose()
            pctBorder.Image = Nothing
        End If
    End Sub

    Private Sub btnFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFolder.Click
        Using fld As New FolderBrowseDialog
            If PathImms.Text <> String.Empty AndAlso Directory.Exists(PathImms.Text) Then
                fld.CurrentPath = PathImms.Text
            Else
                fld.CurrentPath = "\"
            End If

            'Open dialog
            fld.ShowDialog()

            'if selected path is not empty set it
            If fld.CurrentPath <> String.Empty Then PathImms.Text = fld.CurrentPath
        End Using
    End Sub

    Private Sub BorderImm_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BorderImm.SelectedIndexChanged
        'Delete picture box image
        If pctBorder.Image IsNot Nothing Then
            pctBorder.Image.Dispose()
            pctBorder.Image = Nothing
        End If

        'If not exist border image exit now
        If Not File.Exists(DirWidget & "\Borders\" & BorderImm.Text) Then Exit Sub

        If BorderBmp IsNot Nothing Then
            BorderBmp.Dispose()
            BorderBmp = Nothing
        End If

        BorderBmp = New Bitmap(pctBorder.Width, pctBorder.Height)
        Using g As Graphics = Graphics.FromImage(BorderBmp)
            g.Clear(BackColor)
            Using FileBorder As New Bitmap(DirWidget & "\Borders\" & BorderImm.Text)
                Dim ia As New ImageAttributes
                ia.SetColorKey(FileBorder.GetPixel(0, 0), FileBorder.GetPixel(0, 0))

                'Draw Border
                g.DrawImage(FileBorder, New Rectangle(0, 0, BorderBmp.Width, BorderBmp.Height), 0, 0, FileBorder.Width, FileBorder.Height, GraphicsUnit.Pixel, ia)
            End Using
        End Using

        'Set picture box image
        pctBorder.Image = BorderBmp
    End Sub
End Class